# distribution	###############################################################

!if ( "$(_DEBUG)" == "" )
!if ( "$(RETAIL)" == "1" )
VERSION		= 4.19a
TARGET_x86	= ..\Release\nodoka.exe				\
			= ..\Release\nodoka_limit.exe		\
			= ..\Release\nodoka.dll				\
			= ..\sirius_sdk\sirius_hook_x86.dll
TARGET_x64	= ..\x64\Release\nodoka64.exe		\
			= ..\x64\Release\nodoka64_limit.exe	\
			= ..\x64\Release\nodoka64.dll		\
			= ..\sirius_sdk\sirius_hook_x64.dll
!else
VERSION		= 4.19a_sample
TARGET_x86	= ..\Sample\nodoka.exe				\
			= ..\Sample\nodoka_limit.exe		\
			= ..\Release\nodoka.dll				\
			= ..\sirius_sdk\sirius_hook_x86.dll
TARGET_x64	= ..\x64\Sample\nodoka64.exe		\
			= ..\x64\Sample\nodoka64_limit.exe	\
			= ..\x64\Release\nodoka64.dll		\
			= ..\sirius_sdk\sirius_hook_x64.dll
!endif
!else
VERSION		= 4.19a_debug
TARGET_x86	= ..\Debug\nodoka.exe				\
			= ..\Debug\nodoka_limit.exe			\
			= ..\Debug\nodoka.dll				\
			= ..\sirius_sdk\sirius_hook_x86.dll
TARGET_x64	= ..\x64\Debug\nodoka64.exe			\
			= ..\x64\Debug\nodoka64_limit.exe	\
			= ..\x64\Debug\nodoka64.dll			\
			= ..\sirius_sdk\sirius_hook_x64.dll
!endif

DISTRIB_BIN	=								\
		..\Release\setup.exe				\
		..\x64\Release\setup64.exe			\
		..\dot.nodoka\nshell.exe			\
		..\gamepad\gamepad.dll				\
		..\gamepad\gamepad64.dll			\
		..\Release\nodoka_helper.exe		\
		..\Release\GuiEdit.exe				\
		..\Release\dotnet_starter.exe		\

DISTRIB_SETTINGS =							\
		..\dot.nodoka\104.nodoka			\
		..\dot.nodoka\104on109.nodoka		\
		..\dot.nodoka\109.nodoka			\
		..\dot.nodoka\109on104.nodoka		\
		..\dot.nodoka\default.nodoka		\
		..\dot.nodoka\default2.nodoka		\
		..\dot.nodoka\emacsedit.nodoka		\
		..\dot.nodoka\dot.nodoka			\
		..\dot.nodoka\doten.nodoka			\
		..\dot.nodoka\dotjp.nodoka			\
		..\dot.nodoka\add-mouse-gamepad.nodoka	\
		..\gamepad\gamepad.nodoka			\
		..\gamepad\gamepad-mouse.nodoka		\
		..\gamepad\gamepad2-mouse.nodoka	\

DISTRIB_MANUAL	=							\
		..\doc\banner-ja.gif				\
		..\doc\CONTENTS-ja.html				\
		..\doc\CONTENTS-en.html				\
		..\doc\CUSTOMIZE-ja.html			\
		..\doc\CUSTOMIZE-en.html			\
		..\doc\edit-setting-ja.png			\
		..\doc\investigate-ja.png			\
		..\doc\log-ja.png					\
		..\doc\MANUAL-ja.html				\
		..\doc\MANUAL-en.html				\
		..\doc\menu-ja.png					\
		..\doc\pause-ja.png					\
		..\doc\README-ja.html				\
		..\doc\README-en.html				\
		..\doc\README.css					\
		..\doc\setting-ja.png				\
		..\doc\syntax.txt					\
		..\doc\target.png					\
		..\doc\version-ja.png				\
		..\doc\tasktray-icon.png			\
		..\doc\copy-ja.png					\
		..\doc\virtualstore-ja.png			\
		..\doc\icon0.png					\
		..\doc\icon1.png					\
		..\doc\icon2.png					\
		..\doc\icon3.png					\
		..\doc\icon4.png					\
		..\doc\icon5.png					\
		..\doc\icon6.png					\
		..\doc\icon7.png					\
		..\doc\regedit.png					\
		..\doc\keyboard.html				\
		..\doc\104.gif						\
		..\doc\109.gif						\
		..\doc\version7-ja.png				\
		..\doc\tasktray-icon7.png			\
		..\doc\tasktray-icon7help.png		\
		..\doc\tasktray-icon7help2.png		\
		..\doc\tasktray-icon7help3.png		\
		..\doc\GuiEdit.png					\
		..\doc\setup.png					\
		..\doc\keyboard_vsd.pdf				\
		..\dot.nodoka\readme.txt			\
		..\dot.nodoka\readme-en.txt			\
		..\dot.nodoka\nshell.txt			\
		..\dot.nodoka\Common_Public_License_1_0.txt	\
		..\dot.nodoka\Common_Public_License_1_0_JP.txt	\
		..\dot.nodoka\nodoka-mode.el		\

DISTRIB_CONTRIBS =							\
		..\contrib\109onAX.nodoka			\
		..\contrib\nodoka-settings.txt		\
		..\contrib\dvorak.nodoka			\
		..\contrib\dvorak109.nodoka			\
		..\contrib\keitai.nodoka			\
		..\contrib\ax.nodoka				\
		..\contrib\98x1.nodoka				\
		..\contrib\DVORAKon109.nodoka		\

DISTRIB_TS4NODOKA =							\
		..\ts4nodoka\thumbsense.nodoka		\
		..\ts4nodoka\sts4nodoka.dll			\
		..\ts4nodoka\cts4nodoka.dll			\
		..\ts4nodoka\ats4nodoka.dll			\
		..\ts4nodoka\ats4nodoka64.dll		\
		..\ts4nodoka\sts4nodoka64.dll		\
		

DISTRIB_DRIVER	=							\
		..\d\i386\nodokad.sys				\
		..\d\amd64\nodokadx64.sys			\
		..\d.rescue\i386\nodokadrsc.sys		\
		..\d.rescue\amd64\nodokadx64rsc.sys	\

DISTRIB		=								\
		$(TARGET_x86)						\
		$(TARGET_x64)						\
		$(DISTRIB_BIN)						\
		$(DISTRIB_SETTINGS)					\
		$(DISTRIB_MANUAL)					\
		$(DISTRIB_CONTRIBS)					\
		$(DISTRIB_DRIVER)					\
		$(DISTRIB_TS4NODOKA)				\


# tools		###############################################################

IEXPRESS	= ..\tools\iexpress.exe
DOCXX		= doc++.exe
MAKEDEPEND	= perl ..\tools\makedepend -o.obj
DOS2UNIX	= perl ..\tools\dos2unix
UNIX2DOS	= perl ..\tools\unix2dos
MAKEFUNC	= perl ..\tools\makefunc
GETCVSFILES	= perl ..\tools\getcvsfiles
GENIEXPRESS	= perl ..\tools\geniexpress
SIGNTOOL	= c:\WinDDK\6001.18002\bin\SelfSign\Signtool


# rules		###############################################################

all:
		-@echo "we need cygwin tool"
		-rm -f nodoka-$(VERSION) 
		-ln -s . nodoka-$(VERSION)
#		-bash -c "tar cvjf nodoka-$(VERSION)-src.tar.bz2 `$(GETCVSFILES) | sed 's/^./nodoka-$(VERSION)/'`"
		-rm -f nodoka-$(VERSION) 
		-$(GENIEXPRESS) \
			nodoka-$(VERSION)$(SAMPLE_NAME)_setup.exe \
			"Nodoka $(VERSION)" \
			setup.exe $(DISTRIB) > __nodoka__.sed
#		-$(UNIX2DOS) $(DISTRIB_SETTINGS) $(DISTRIB_CONTRIBS)
		-$(IEXPRESS) /N __nodoka__.sed
#		-$(DOS2UNIX) $(DISTRIB_SETTINGS) $(DISTRIB_CONTRIBS)
#		-$(RM) __nodoka__.sed
		-$(SIGNTOOL) sign /v /ac d:\nodoka\MSCV-GlobalSign.cer /s my /n "G.K. Applet" nodoka-$(VERSION)$(SAMPLE_NAME)_setup.exe
#		-$(SIGNTOOL) sign /v /ac d:\nodoka\MSCV-GlobalSign.cer /s my /n "G.K. Applet" /t http://timestamp.globalsign.com/scripts/timstamp.dll nodoka-$(VERSION)$(SAMPLE_NAME)_setup.exe
